// Package rhyzome provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.10.1 DO NOT EDIT.
package rhyzome

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/url"
	"path"
	"strings"

	"github.com/getkin/kin-openapi/openapi3"
)

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+xYT2/buBP9KgR/P2AviuX+wR582jT2Bi4C1+s0h0VRGLQ0tplKJEuOnLqBv/uClGRJ",
	"FuXEaQNki73J4nD45vFx+OR7GslUSQECDR3cUxOtIWXu8UIDQxgLg0xEMIOvGRh8J+OtHVRaKtDIwYUu",
	"mIE5T9kK7C/cKqADalBzsaK7gEYqq73nAmEF2g7E3HyZG/4d/MMppFJv/WOZAT2PGTLPiruAaviacQ0x",
	"HXwq0+Q4gjrYOoLPQZlGLm4hQrvIIQVGSWHAzwEvouY89pJwKxf+oQO0RVzQSOgDN9Ja6jaOSMaOzqXU",
	"KcOctDevaeDl1xj/nh1gcjmreB+akiQPoK7dP7a9oqiiRaMGIzPdTbOWEucbmWSpf75Bhm4ERJba2qaj",
	"yXA8uaQBvZiNzj/mj7ObySR/uv74YTodDWlAh6OrUTHsHt3L0Wz2YVYjpFroBIHWawoO5Spy7ut1lVX4",
	"9uG9XHi2wOk4nls9NJXx+1uvMjrFmg/lLx/D7l83oxtHVMXo8MNkRAP65/n4ajT0UueyzBG+4QnHZY+r",
	"RNHIE9Q56OBtBss2dSceW1/qCeCd1F88LeMReTtyTrXccMOl4GI1ErGSvGjgzRVWWkUdGwXq4cXd9CL4",
	"IRRjsZQe5bH5kosVaKW5QC8UqMP/v7abQP8XVtdSWNxJob/mQ8xVuuBw9XYJdjIvgEdSIIscRkgZT9yJ",
	"WMo/QCATqwRSENhbMR2DsMeS2QZDR7VBclkOZtrOXiMqMwhDXwJ7+YGJNFfIpaADChvQW1xzsSImc+gI",
	"ShKtmVgBueO4lhkSIZFHVtkJj0AYd9IKIBcXZ+/+Prs+P3vb67cQOO3zDUQyTaUwPalXYZHChItt+LbX",
	"Dy0k5JjYZLP19rtMgWz65Hw6pgHdgDY5zn7vVa9vY6UCwRSnA/qm13drKoZrt4lh7w6S5OyLkHci1Hmu",
	"MGI9BakTJTiSm/V/XAO5OCeRlc6SRwyBLKUmuAYSJZlB0IQZYjO4pTWz88YxHTREeMGmLkIXV7WhA5El",
	"id1mLyhVm9u7NRZJB75ptkh4ROoTiJUHKfV2FJc7HA1Y9/R1v1/KDvKjwZRKbOlcirAEk4v/lKPh1nLK",
	"bjNc1E1Kb/GbaVZ0M7u6tnMtX5t+yGuXupeVK26QsCTZJzQtGmzIeZKMawE/RANHSB9sFXs3stsfeaY1",
	"2/p4YSSxVcjlQSEucMmyBH/aNuWWzYMhE/BNQYQQE6hilDQeznNTSpjYY21x3vStNG+QNff+U4rp/j7w",
	"FGjPsYC7PWTX3FwCWm/fqDPYtQTy6tkw1wx9B+g9YG7IAuwZKYyE55iE9zze5RuWQO6Dmgnz90e3buhC",
	"alunmGYpIGhDB58OE46HVrd1Uoul7bVGB64lV5eV80lNsoMacYde4PMzNqzCbnlIbxOelxTnwd42FAMy",
	"nhjCFvaWPEbvJeDTuV0CRusXT23V+44rukvAoUGmHQZ//3HDR0m+thFPpzlf/1dSsKuou2WEBqU6RrhU",
	"D/At1X901+mWSjXovpULs+/O3hayAnRm034zZsa5AaKYRh5lCdPkVi58veS9e/0IwvP5L57irp4RZVrb",
	"Lxz3RW3rsS9v8/hDikODGli302eCwMYu7MJsskzFDMFYMZZ52xK3wS+QboRvGLp6zqq6f4jvNj9NXbap",
	"F9UfDMddehHYadIn1fjze/Tyb5GTLfq+ipfv0Mud8Rv0yX702QzvnuQuS+6Gj5nbIuQEb9tVdG5tq6If",
	"cY5LfL+CsW1x/QRf20XtJeBTef13mNrH6djJdrf7JwAA///l6L5/1RoAAA==",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
